.include "m8def.inc"
.def tmp = r16;
;R2 - - 
;R3 -   
;R4 -   
;R5 -  
;R6 -   
;R7 -  
;R16, R17 -  
;
.ORG $000
rjmp RESET;				 
;
.ORG $013
RESET:;					  
ldi tmp, high(RAMEND);	[..
out SPH, tmp;			...
ldi tmp, low(RAMEND);	...
out SPL, tmp;			 ]
;
ser tmp;
out DDRD, tmp;			    - 
ldi tmp, 1;
out DDRC, tmp;			 .1   - 
mov r2, tmp;			   
;
ldi tmp, 252;			[..
mov r4, tmp;			  ]
ldi tmp, 247;			[..
mov r6, tmp;			 ]
;
ldi tmp, 203;			[..     
mov r3, tmp;			...
out TCNT0, r3;			Timer0 start value]
ldi tmp, 0b00000100;	[..
out TCCR0, tmp;			start Timer0, prescaling/256]
;
ldi XH, $01;			[..
clr XL;					     $100]
;
kadr:;					{ 
sbi PORTC, 0;			[..
out PORTD, tmp;			...( "0"  ),  
cbi PORTC, 0;			 ]
ldi r17, 255;			[..
nop;					...
dec r17;				...
brne PC-2;				]
;
stolb:;					[  :
ld tmp, X+; 			    
out PORTD, tmp; 		  
ldi r17, 9;				[[.
dec r17;				...
brne PC-1;				   ]]
tst XL;					     - 
brne stolb;				    ]
;
dec XH;					  ,  ldi XH, $01
clr tmp;				[...
out PORTD, tmp;			...( "0"  )]
;
test_fall:;				[    
inc r5;					  
brne test_birth;		 ,   
mov r5, r4;				   ]
;
fall:;					[  
ld tmp, X; 				 
tst tmp; 				      $FF
breq PC+2; 				  , ...
dec tmp; 				 
st X+, tmp;				 
tst XL; 				     - 
breq PC+2; 				    
rjmp fall;
dec XH;					  ,  ldi XH, $01]
;
test_birth:;			[    
inc r7;					  
brne end_kadr;			 ,   
mov r7, r6;				   ]
;
birth:;					[   
clr tmp;
bst r2, 0; 				     ""
lsr r2; 				  
bld tmp, 7; 			 ""  7- 
bld tmp, 6; 			 ""  6- 
bld tmp, 5; 			 ""  5- 
bld tmp, 0; 			 ""  0- 
eor r2, tmp; 			. 
mov XL, r2;				       
ser tmp;				    $FF
st X, tmp;				 
clr XL;					]
;
end_kadr:;
in r17, TIFR;			[..
sbrs r17, 0;			...
rjmp PC-2;				   0]
;
out TCNT0, r3;			   
ldi tmp, 0b00000001;	[..
out TIFR, tmp;			   ]
rjmp kadr;				} 
